import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import { WhListItem, WhPageListGetResultModel, WhPageParams } from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';

/*
 * 获取仓库分页列表
 */
export const getWhListByPage = async (params: WhPageParams) => {
  let sqlcmd = '';
  if (params?.WH_CODE != undefined && params?.WH_CODE != '') {
    sqlcmd += " And WH_CODE = '" + params?.WH_CODE + "'";
  }
  if (params?.WH_NAME != undefined && params?.WH_NAME != '') {
    sqlcmd += "And WH_NAME like '%" + params?.WH_NAME + "%'";
  }
  const rParams = genActionPage('WMS_WAREHOUESE', sqlcmd, params.page, params.pageSize);
  return getWhListByPageAsync(rParams);
};
async function getWhListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
    },
  );
  const model: WhPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  return model;
}

export const SaveWh = async (params: any, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('WMS_WAREHOUESE', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('WMS_WAREHOUESE', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};

export const DeleteWh = async (params: Recordable) => {
  const usParams = genAction('WMS_WAREHOUESE', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
